"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
/**
 *
 * documentations:
 * https://www.npmjs.com/package/html-react-parser
 * https://github.com/wooorm/lowlight?tab=readme-ov-file
 * https://github.com/GeoffSelby/tailwind-highlightjs
 * https://highlightjs.org/examples (list of all available themes)
 * https://medium.com/@hizacharylee/simplify-syntax-highlighting-with-highlight-js-b65af3bdc509 (custom css theme, not used here)
 *
 */
require("./index.css");
const html_react_parser_1 = __importStar(require("html-react-parser"));
const lowlight_1 = require("lowlight");
const hast_util_to_html_1 = require("hast-util-to-html");
const lowlight = (0, lowlight_1.createLowlight)(lowlight_1.common);
const parseHtml = (
/**
 * The stringified html to be parsed (to HTML).
 * example: `<p><h1>Hello there</h1><code>console.log('Hello, World!')</code></p>`
 */
text, classNames, language = 'javascript', options) => {
    const { codeClassName } = classNames || {};
    /**
     * Parse the html string content and highlight the code snippets
     */
    const defaultOptions = {
        /**
         * Replace the `<code>` with the highlighted code snippet
         * the string content of the `<code>` tag is transformed to stringified html using the lowlight library
         * the stringified html is then highlighted using the `highlight` theme
         * for that to work with tailwindcss, we are use tailwindcss plugin `tailwind-highlightjs`
         * hast trees as returned by lowlight can be serialized to HTML using `hast-util-to-html`
         * finally the highlighted code snippet is parsed to react component using the `parse` function of `html-react-parser`
         * @param domProps
         * @returns
         */
        replace(domProps) {
            const { name, children, attribs } = domProps;
            const Component = name;
            if (name) {
                const props = (0, html_react_parser_1.attributesToProps)(attribs);
                // do not replace the `<pre>` tag
                if (name === 'pre')
                    return;
                /**
                 * Replace the `<code>` tag with the highlighted code snippet
                 * with the `hljs` class name to apply the highlight theme (see: https://highlightjs.org/examples/)
                 */
                if (name === 'code') {
                    const codeStr = (0, html_react_parser_1.domToReact)(children);
                    const tree = lowlight.highlight(language, codeStr);
                    return ((0, jsx_runtime_1.jsx)("code", Object.assign({ className: `hljs code-container ${codeClassName || ''}` }, props, { children: (0, html_react_parser_1.default)((0, hast_util_to_html_1.toHtml)(tree)) })));
                }
                if (name === 'image') {
                    return (0, jsx_runtime_1.jsx)(Component, Object.assign({}, props, { className: (classNames === null || classNames === void 0 ? void 0 : classNames.imageClassName) || '' }));
                }
                if (['br', 'hr', 'img'].find((currentName) => currentName === name)) {
                    return (0, jsx_runtime_1.jsx)(Component, Object.assign({}, props));
                }
                return ((0, jsx_runtime_1.jsx)(Component, Object.assign({ className: (classNames === null || classNames === void 0 ? void 0 : classNames[`${name}ClassName`]) || '' }, props, { children: (0, html_react_parser_1.domToReact)(children) })));
            }
        }
    };
    /*
    * If the `<code>` tag is not found in the html string content
    * it means that there are no code snippets to be highlighted.
    */
    return (0, html_react_parser_1.default)(text, Object.assign(Object.assign({}, defaultOptions), options));
};
const TiptapParser = (_a) => {
    var { classNames, containerClassName, language, children } = _a, rest = __rest(_a, ["classNames", "containerClassName", "language", "children"]);
    return ((0, jsx_runtime_1.jsx)("div", { className: containerClassName, children: parseHtml(children, classNames, language, rest) }));
};
exports.default = TiptapParser;
