/**
 *
 * documentations:
 * https://www.npmjs.com/package/html-react-parser
 * https://github.com/wooorm/lowlight?tab=readme-ov-file
 * https://github.com/GeoffSelby/tailwind-highlightjs
 * https://highlightjs.org/examples (list of all available themes)
 * https://medium.com/@hizacharylee/simplify-syntax-highlighting-with-highlight-js-b65af3bdc509 (custom css theme, not used here)
 *
 */
import './index.css';
import { HTMLReactParserOptions } from 'html-react-parser';
export type ClassNamesProps = {
    codeClassName?: string;
    h1ClassName?: string;
    h2ClassName?: string;
    h3ClassName?: string;
    h4ClassName?: string;
    h5ClassName?: string;
    h6ClassName?: string;
    pClassName?: string;
    ulClassName?: string;
    liClassName?: string;
    spanClassName?: string;
    divClassName?: string;
    aClassName?: string;
    tableClassName?: string;
    imageClassName?: string;
};
export type TiptapProps = {
    children: string;
    classNames?: ClassNamesProps;
    language?: string;
    containerClassName?: string;
} & HTMLReactParserOptions;
declare const TiptapParser: ({ classNames, containerClassName, language, children, ...rest }: TiptapProps) => import("react/jsx-runtime").JSX.Element;
export default TiptapParser;
